# Service to expose and loadbalance between pods.
apiVersion: v1
kind: Service
metadata:
  name: jobtech-jobad-enrichments-frontend-v2
spec:
  selector:
    app: jobtech-jobad-enrichments-frontend-v2
  ports:
    - protocol: TCP
      port: 80
      targetPort: 8080
---
# Deployment to create necessary pods with configurations.
apiVersion: apps/v1
kind: Deployment
metadata:
  name: jobtech-jobad-enrichments-frontend-v2
  labels:
    app: jobtech-jobad-enrichments-frontend-v2
spec:
  selector:
    matchLabels:
      app: jobtech-jobad-enrichments-frontend-v2
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 0
  template:
    metadata:
      labels:
        app: jobtech-jobad-enrichments-frontend-v2
    spec:
      securityContext:
        # Your app shall always run as nonroot.
        runAsNonRoot: true
      affinity:
        # Avoid to run many pods on same physical node. It increases reliability.
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
          - weight: 1
            podAffinityTerm:
              labelSelector:
                matchLabels:
                  app: jobtech-jobad-enrichments-frontend-v2
              topologyKey: kubernetes.io/hostname
      containers:
      - name: nginx
        image: docker-images.jobtechdev.se/jobtech-jobad-enrichments-frontend-v2/jobtech-jobad-enrichments-frontend-v2:latest
        imagePullPolicy: Always
        ports:
        - containerPort: 8080
        readinessProbe:
          initialDelaySeconds: 5
          httpGet:
            path: /
            port: 8080
        livenessProbe:
          initialDelaySeconds: 5
          failureThreshold: 2
          httpGet:
            path: /
            port: 8080
        securityContext:
          # Your app shall always have the container file system read only. Use volumes for temp areas etc.
          readOnlyRootFilesystem: true
          allowPrivilegeEscalation: false
        resources:
          limits:
            memory: "64Mi"
          requests:
            cpu: "100m"
            memory: "64Mi"
        volumeMounts:
        - name: tmp
          mountPath: /tmp
        - name: tmp
          mountPath: /var/lib/nginx/body
        - name: tmp
          mountPath: /var/lib/nginx/proxy
        - name: tmp
          mountPath: /var/lib/nginx/fastcgi
        - name: tmp
          mountPath: /var/lib/nginx/uwsgi
        - name: tmp
          mountPath: /var/lib/nginx/scgi
        - name: tmp
          mountPath: /run
      volumes:
      - name: tmp
        emptyDir: {}
